function builtinker(kerV,derV,kerI,derI)

% build specified kernels in current directory matlab codes
% kerV, derV : deformation kernel and its derivative
% kerI, derI : matching kernel and its derivative
% kernels are expressed as functions of -|x-y|^2/sigma^2
% arguments must be strings containing the functions with argument arg
% eg1 : builtinker('exp(arg)','exp(arg)','exp(arg)','exp(arg)')
% eg2 : builtinker('1/(1-arg)','1/(1-arg)^2','1/(1-arg)','1/(1-arg)^2')
%
% author : Joan Glaunès - joan.glaunes@free.fr

sourcetab = dir('*.m');
for s = 1:length(sourcetab);
    source = sourcetab(s).name;
    if ~strcmp(source,'builtinker.m')
        f = fopen(source,'r');
        code = fscanf(f,'%c',inf);
        fclose(f);
        
        if findstr(code,'%% BUILT IN KERNEL')
            for item = {'kerV','kerI','derV','derI'}
                item1 = item{1};
                code = regexprep(code,['[^\n\r]*%% BUILT IN KERNEL ',item1], ...
                    ['arg = ',eval(item1),';  %% BUILT IN KERNEL ',item1]);
            end
            
            f = fopen(source,'w');
            fprintf(f,'%c',code);
            fclose(f);
            
            disp(['file ',source,' modified'])
        end
    end    
end
